
#ifndef __GSM0710MUX_H__
#define __GSM0710MUX_H__

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <fsotransport.h>
#include <glib-object.h>

G_BEGIN_DECLS


#define GSM0710MUX_TYPE_CHANNEL_TYPE (gsm0710mux_channel_type_get_type ())

#define GSM0710MUX_TYPE_CHANNEL_INFO (gsm0710mux_channel_info_get_type ())
typedef struct _Gsm0710muxChannelInfo Gsm0710muxChannelInfo;

#define GSM0710MUX_TYPE_MANAGER (gsm0710mux_manager_get_type ())
#define GSM0710MUX_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSM0710MUX_TYPE_MANAGER, Gsm0710muxManager))
#define GSM0710MUX_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSM0710MUX_TYPE_MANAGER, Gsm0710muxManagerClass))
#define GSM0710MUX_IS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSM0710MUX_TYPE_MANAGER))
#define GSM0710MUX_IS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSM0710MUX_TYPE_MANAGER))
#define GSM0710MUX_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSM0710MUX_TYPE_MANAGER, Gsm0710muxManagerClass))

typedef struct _Gsm0710muxManager Gsm0710muxManager;
typedef struct _Gsm0710muxManagerClass Gsm0710muxManagerClass;
typedef struct _Gsm0710muxManagerPrivate Gsm0710muxManagerPrivate;

typedef enum  {
	GSM0710MUX_MUXER_ERROR_CHANNEL_TAKEN,
	GSM0710MUX_MUXER_ERROR_INVALID_CHANNEL,
	GSM0710MUX_MUXER_ERROR_INVALID_TRANSPORT,
	GSM0710MUX_MUXER_ERROR_NO_SESSION,
	GSM0710MUX_MUXER_ERROR_NO_CHANNEL,
	GSM0710MUX_MUXER_ERROR_SESSION_ALREADY_OPEN,
	GSM0710MUX_MUXER_ERROR_SESSION_OPEN_ERROR
} Gsm0710muxMuxerError;
#define GSM0710MUX_MUXER_ERROR gsm0710mux_muxer_error_quark ()
typedef enum  {
	GSM0710MUX_CHANNEL_TYPE_DELEGATE,
	GSM0710MUX_CHANNEL_TYPE_PTY,
	GSM0710MUX_CHANNEL_TYPE_SOCKET
} Gsm0710muxChannelType;

struct _Gsm0710muxChannelInfo {
	gint number;
	Gsm0710muxChannelType type;
	char* consumer;
	char* transport;
	FsoFrameworkTransportReadFunc readfunc;
	gpointer readfunc_target;
	FsoFrameworkTransportHupFunc hupfunc;
	gpointer hupfunc_target;
};

struct _Gsm0710muxManager {
	GObject parent_instance;
	Gsm0710muxManagerPrivate * priv;
};

struct _Gsm0710muxManagerClass {
	GObjectClass parent_class;
};


GQuark gsm0710mux_muxer_error_quark (void);
GType gsm0710mux_channel_type_get_type (void);
GType gsm0710mux_channel_info_get_type (void);
Gsm0710muxChannelInfo* gsm0710mux_channel_info_dup (const Gsm0710muxChannelInfo* self);
void gsm0710mux_channel_info_free (Gsm0710muxChannelInfo* self);
void gsm0710mux_channel_info_copy (const Gsm0710muxChannelInfo* self, Gsm0710muxChannelInfo* dest);
void gsm0710mux_channel_info_destroy (Gsm0710muxChannelInfo* self);
GType gsm0710mux_manager_get_type (void);
Gsm0710muxManager* gsm0710mux_manager_new (void);
Gsm0710muxManager* gsm0710mux_manager_construct (GType object_type);
char* gsm0710mux_manager_repr (Gsm0710muxManager* self);
char* gsm0710mux_manager_getVersion (Gsm0710muxManager* self);
gboolean gsm0710mux_manager_hasAutoSession (Gsm0710muxManager* self);
void gsm0710mux_manager_openSession (Gsm0710muxManager* self, gboolean advanced, gint framesize, const char* port, gint portspeed, GError** error);
void gsm0710mux_manager_closeSession (Gsm0710muxManager* self, GError** error);
void gsm0710mux_manager_allocChannel (Gsm0710muxManager* self, Gsm0710muxChannelInfo* channel, GError** error);
void gsm0710mux_manager_releaseChannel (Gsm0710muxManager* self, const char* name, GError** error);
void gsm0710mux_manager_setWakeupThreshold (Gsm0710muxManager* self, guint seconds, guint waitms, GError** error);
void gsm0710mux_manager_setStatus (Gsm0710muxManager* self, gint channel, const char* status, GError** error);
void gsm0710mux_manager_testCommand (Gsm0710muxManager* self, guint8* data, int data_length1, GError** error);


G_END_DECLS

#endif
